//  Projection Mapping Seminar
//  Mac version
//
//  Send Processing sketch content to a Syphon receiver

import processing.video.*;
import codeanticode.syphon.*;

Capture cam;
//PGraphics pgr;
int mode; //0,1: send a static image via Spout, 2: send webcam input
SyphonServer server;
PImage mImg, fImg;
boolean update;
String[] cameras;

void settings() {
  size(640, 480, P3D);
  PJOGL.profile=1;
}

void setup() {
  // Create syhpon server to send frames out.
  server = new SyphonServer(this, "Processing Syphon");

  cameras = Capture.list();
  
  if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    //exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    cam = new Capture(this, cameras[0]);
    cam.start();     
  }      
  
  mode = 1;
  mImg =loadImage("m_source.png");
  fImg =loadImage("f_source.png");
  update = true;
}

void draw() {
  switch(mode) {
    case 1: 
      image(mImg, 0, 0);
      break;
    case 2: 
      image(fImg, 0, 0);
      break;
    case 3: 
      if (cameras.length != 0 && cam.available() == true && update)
        cam.read();
      else
        break;
      image(cam, 0, 0, width, height);
      break;
  }
  
  server.sendScreen();
}

void keyPressed() {
  if (key == '1')
    mode = 1;
  else if  (key == '2')
    mode = 2;
  else if  (key == '3')
    mode = 3;
  else if  (key == ' ')
    update = ! update;
}